/*
 *      benchmark.h
 *
 *      Copyright © 2010 Dionisio E Alonso <dealonso@gmail.com>
 *
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#define BENCH_START() \
	{								\
		struct timeval *t1=NULL, *t2=NULL;			\
		t1 = (struct timeval *) calloc(1,			\
						sizeof(struct timeval));\
		t2 = (struct timeval *) calloc(1, 			\
						sizeof(struct timeval));\
									\
		gettimeofday(t1, NULL);

#define BENCH_STOP() \
		gettimeofday(t2, NULL);					\
									\
		fprintf(stderr, "%f secs\n",				\
				(t2->tv_sec + t2->tv_usec*1e-6) - 	\
				(t1->tv_sec + t1->tv_usec*1e-6));	\
		free(t1);						\
		free(t2);						\
	}

#define BENCHMARK(f) 							\
	{								\
		BENCH_START()						\
									\
		f;							\
									\
		BENCH_STOP()						\
	}
