#include <stdio.h>

#define BLOCK_SIZE 512
#define DEVICE 0

#define DIV_CEIL(a,b) (a+b-1)/b

#define CUDA_SAFE_CALL(call)										\
	do {															\
		cudaError err = call;										\
		if( cudaSuccess != err) {									\
			fprintf(stderr,											\
					"Cuda error in file '%s' in line %i : %s.\n",	\
					__FILE__, __LINE__, cudaGetErrorString(err));	\
			exit(EXIT_FAILURE);										\
		}															\
	} while(0)

#define CUT_CHECK_ERROR(errorMessage)									\
	do {																\
		cudaThreadSynchronize();										\
		cudaError_t err = cudaGetLastError();							\
		if( cudaSuccess != err) {										\
			fprintf(stderr,												\
					"Cuda error: %s in file '%s' in line %i : %s.\n",	\
					errorMessage, __FILE__, __LINE__,					\
					cudaGetErrorString(err)); 							\
			exit(EXIT_FAILURE);											\
		}																\
	} while (0)
