/*
 *      function.cu
 *
 *      Copyright © 2010 Dionisio E Alonso <dealonso@gmail.com>
 *
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <math.h>

__device__ double f(double x, int n) {
	int i=0;
	double num=1;

	for (i=1; i<=n; i++) {
		num *= 2*i-1;
	}

	return powf(-1,n)*num/powf(2,n)*2/sqrtf(M_PI)*expf(-pow(x,2))/powf(x,2*n);
}
